package etomo.comscript;

/**
* <p>Description: Generic interface for params used by classes which implement
* ParallelDialog.
* 
* Implemented by:
* ProcesschunksParam</p>
* 
* <p>Copyright: Copyright (c) 2005</p>
*
* <p>Organization:
* Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEM),
* University of Colorado</p>
* 
* @author $Author: sueh $
* 
* @version $Revision: 1.3 $
*/
public interface ParallelParam {
  public static  final String  rcsid =  "$Id: ParallelParam.java,v 1.3 2007/12/10 21:57:44 sueh Exp $";
  
  public CommandMode getSubcommandMode();
}
/**
* <p> $Log: ParallelParam.java,v $
* <p> Revision 1.3  2007/12/10 21:57:44  sueh
* <p> bug# 1041 Removed getProcessName.  Using getRootName instead because
* <p> that is what needs to be saved to do a resume after etomo has exited and
* <p> restarted.
* <p>
* <p> Revision 1.2  2007/11/06 19:14:35  sueh
* <p> bug# 1047 Added getProcessName and getSubcommandMode.
* <p>
* <p> Revision 1.1  2005/09/16 17:19:06  sueh
* <p> bug# 532 A generic interface for ProcesschunksParam.  Allows
* <p> ApplicationManager to have only one function which sets parameters in
* <p> processchunks.  This is done by using ParallelDialog to represent the
* <p> dialog.
* <p> </p>
*/