package etomo.storage;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2002, 2003, 2004</p>
 *
 * <p>Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEM),
 * University of Colorado</p>
 *
 * @author $$Author: sueh $$
 *
 * @version $$Revision: 1.2 $$
 *
 * <p> $$Log: DistortionFileFilter.java,v $
 * <p> $Revision 1.2  2009/09/01 03:18:06  sueh
 * <p> $bug# 1222
 * <p> $
 * <p> $Revision 1.1  2004/02/20 23:43:25  sueh
 * <p> $bug# 386 looks for .idf files
 * <p> $$ </p>
 */
public class DistortionFileFilter extends FileFilter {
  public static final String rcsid = "$$Id: DistortionFileFilter.java,v 1.2 2009/09/01 03:18:06 sueh Exp $$";

  /**
   * @see javax.swing.filechooser.FileFilter#accept(File)
   */
  public boolean accept(File f) {
    //  If this is a file test its extension, all others should return true
    if (f.isFile() && !f.getAbsolutePath().endsWith(".idf")) {
      return false;
    }
    return true;
  }

  /**
   * @see javax.swing.filechooser.FileFilter#getDescription()
   */
  public String getDescription() {
    return "Image Distortion FieldInterface File";
  }

}
