package etomo.storage;

import java.io.File;

import javax.swing.filechooser.FileFilter;
/**
* <p>Description: File filter for mag gradients correction files (.mgt).</p>
* 
* <p>Copyright: Copyright (c) 2005</p>
*
*<p>Organization:
* Boulder Laboratory for 3-Dimensional Electron Microscopy of Cells (BL3DEM),
* University of Colorado</p>
* 
* @author $Author: sueh $
* 
* @version $Revision: 1.1 $
*/
public class MagGradientFileFilter extends FileFilter {
  public static  final String  rcsid =  "$Id: MagGradientFileFilter.java,v 1.1 2005/03/02 00:11:47 sueh Exp $";
  /**
   * @see javax.swing.filechooser.FileFilter#accept(File)
   */
  public boolean accept(File f) {
    //  If this is a file test its extension, all others should return true
    if (f.isFile() && !f.getAbsolutePath().endsWith(".mgt")) {
      return false;
    }
    return true;
  }

  /**
   * @see javax.swing.filechooser.FileFilter#getDescription()
   */
  public String getDescription() {
    return "Mag Gradients Correction File";
  }
}
/**
* <p> $Log: MagGradientFileFilter.java,v $
* <p> Revision 1.1  2005/03/02 00:11:47  sueh
* <p> bug# 611 Added mag gradients correction file.
* <p> </p>
*/
