.na
.nh
.TH imod2vrml 1 2.00 BL3DEMC
.SH NAME
imod2vrml \- Make a VRML model from an IMOD model file.
.SH SYNOPSIS
imod2vrml [-l] <IMOD model> <vrml file>
.SH DESCRIPTION
Convert an IMOD model file to the VRML 1.0 file format used
by WWW browsers and VRML viewers.  The model will generally 
have similar attributes to
those set in 3dmodv(1) before the conversion.
Specifically, objects that are turned off will not
be included in the VRML file.  For open or closed contour objects,
the various combinations of the "Data Type"
(Contour versus Mesh) and the "Drawing Style" (Points, Lines, Fill, and Fill
Outline) should all appear in the VRML model as they do in 3dmodv.  
However, scattered points will always display as shaded spheres, regardless of
which of these options are selected.
A Fill
Color will be used in place of the line color if that option was set in 3dmodv.
.P
For shaded surfaces, the intensity levels may be quite different
in the VRML viewer than in 3dmodv, depending on the settings in the viewer.
If you are generating files for a particular VRML viewer, you can adjust
the Material
properties in 3dmodv to get the desired appearance in the viewer.  
The Ambient setting will have no effect, so adjust intensity primarily with
the Diffuse setting, and then with the Specular and Shininess settings.
Transparency may also need to be set higher to achieve the desired level, as
well to minimize artifacts from overlapping transparent
surfaces which become more evident at some orientations.
.SS Options
.TP 
.B -l
Use low-resolution meshes, if any are available.  The default is to use the
highest resolution meshes contained in the model.  Low resolution meshes can
be produced with the 
.B -l
option to imodmesh(1).
.SH AUTHORS
Jim Kremer and David Mastronarde
.SH SEE ALSO
3dmodv(1), imodmesh(1)
.SH BUGS
Email bug reports to mast@colorado.edu.
