.na
.nh
.TH matchorwarp 1 2.30 BL3DEMC
.SH NAME
matchorwarp \- Find registration between two volumes and transform one
.SH SYNOPSIS
matchorwarp [options] <input file>  <output file>
.SH DESCRIPTION
Matchorwarp runs Refinematch(1) to attempt to find a single linear
transformation relating two volumes.  If a single transformation gives an
adequate fit, Matchorwarp runs Matchvol(1) to generate the output file from
the input file.  Otherwise, it runs Findwarp(1) to find a
set of warping transformations that relate the two volumes.
If an adequate fit is found, it then runs Warpvol(1) to generate the input 
file from the output file; otherwise it exits with an error.
There are options to run Matchorwarp in a trial mode and to exclude rows or
columns of patches, so this program can be used to explore different fits 
before or instead of running Findwarp(1) interactively.
.SS Options
Give the command "matchorwarp" without arguments to see a list of the current
defaults for many of these options.  Options may be abbreviated to the minimum
number of unambiguous characters.
.TP
.B -size <size>
Specifies the size of the volume being matched to; "size"
can be either the name of one of that file or its NX,NY,NZ dimensions.
.TP
.B -refinelimit <value>
Specifies the maximum mean residual that will be allowed when running 
Refinematch(1) and Matchvol(1).
.TP
.B -warplimit <value1,value2,...>
Specifies a list of mean residuals that Warpvol(1) will attempt to achieve
automatically.  Values should be in increasing order.
.TP
.B -modelfile <model file>
Name of a model file with contours enclosing the patches to include in fits.
.TP
.B -patchfile <patch file>
Name of the existing file with list of patch displacements (default patch.out).
.TP
.B -solvefile <solve file>
Name of the existing file with the initial transformation between volumes 
(default solve.xf).
.TP
.B -refinefile <refine file>
Name of the file into which refinematch will place the refining transformation.
(default refine.xf).
.TP
.B -inversefile <inverse file>
Name of the file into which matchvol will place the inverse cumulative
transformation (default inverse.xf).
.TP
.B -warpfile <warp file>
Name of the file into which warpvol will place the inverse warping 
transformations (default warp.xf).
.TP
.B -residualfile <residual file>
Name of the file into which Refinematch(1) and/or Warpvol(1) will place a new
list of the patches, their displacements, and the residual from the fits.
.TP
.B -vectormodel <model file>
Name of patch vector model file to create from the residual file with 
Patch2imod(1).
.TP
.B -clipsize <value>
If writing a patch vector model, set up four clipping planes enclosing a
square central area of the given size.
.TP
.B -tempdir <temporary directory>
Path name of directory into which matchvol or warpvol can place temporary
files.
.TP
.B -xlowerexclude <value>
Specifies the number of columns of patches to exclude on the left side of
the volume.
.TP
.B -xupperexclude <value>
Specifies the number of columns of patches to exclude on the right side of
the volume.
.TP
.B -ylowerexclude <value>
Specifies the number of rows or slabs of patches to exclude on the lower Y side
of the volume.
.TP
.B -yupperexclude <value>
Specifies the number of rows or slabs of patches to exclude on the upper Y side
of the volume.
.TP
.B -zlowerexclude <value>
Specifies the number of slabs or rows of patches to exclude on the lower Z
side of the volume.  This would be used to specify rows on the bottom when 
viewing a volume in flipped orientation.
.TP
.B -zupperexclude <value>
Specifies the number of slabs or rows of patches to exclude on the upper Z
side of the volume.  This would be used to specify rows on the top when 
viewing a volume in flipped orientation.
.TP
.B -linear
Uses linear instead of quadratic interpolation for transforming the volume
with Matchvol or Warpvol.
.TP
.B -trial
Activates trial mode, in which the program exits after finding a good fit
rather than going on to matchvol or warpvol.
.SH FILES
Unless optional arguments are entered, the program assumes the existence of
patch.out and solve.xf.
.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
patchcrawl3d(1), refinematch(1), matchvol(1), findwarp(1), warpvol(1),
patch2imod(1)
