.na
.nh
.TH matchshifts 1 2.30 BL3DEMC
.SH NAME
matchshifts \- Find shift component of transformation between two volumes
.SH SYNOPSIS
matchshifts root_name1 root_name2 NX NY NZ [xf_in] [xf_out]
.SH DESCRIPTION
Matchshifts uses cross correlation to complete the process of finding an 
initial transformation between two volumes.  It is now obsolete but was needed
because older versions of Tiltalign produces relative fiducial coordinates,
from which the shifts in X, Y, and Z could not be deduced by Solvematch.
It will now take the output of Solvematch, assumed to be solvezero.xf, and
determine whether the transformation already contains shifts.  If it does, 
the solvezero.xf is simply copied to solve.xf.

If Matchshifts finds a 3x3 transformation matrix with zero shifts in
solvezero.xf, it projects each volume
into the X-Z plane, or the central 1024 by 1024 pixels if the volumes are
larger than that.  It rotates the projection of the second volume using
appropriate terms from the transformation matrix, then cross-correlates this
rotated projection with the projection of the first volume to obtain an
initial estimate of shifts in X and Z.  In this way, quite large shifts between
the volumes can be determined.  Next, it extracts a subset from the
center of the first volume and uses matchvol to extract and transform the
approximately corresponding subset of the second volume.  The two subsets are
cross-correlated in 3-D to estimate the shifts in X, Y, and Z.  With these
final shifts, it then extracts a subset volume just adjacent to the central
subsets and uses 3-D correlation to check whether the shifts are correct.
If the displacement between these two volumes is too large, matchshifts
exits with an error message and a non-zero status.
.SH ARGUMENTS
root_name1 and root_name2 are the root names (without extension .rec) of the
first and second volumes.

NX, NY, NZ are the X, Y, and Z dimensions of the small volume that will be
extracted for 3-D cross-correlation.

An optional sixth argument (xf_in) can be used to specify the name of the
file with the initial 3x3 transformation and zero shifts; otherwise the
file is assumed to be solvezero.xf.

An optional seventh argument (xf_out) can be used to specify the output 
file for the completed transformation; otherwise this file will be solve.xf.
.SH FILES
The program leaves the subset volumes used for checking the alignments.
These files are matchcheck.rec and matchcheck.mat.
The program assumes that volumes have the extension ".rec" and, unless there is
a sixth argument, it assumes that the 3x3 transformation is in solvezero.xf.
.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
solvematch(1), xyzproj(1), matchvol(1), tiltxcorr(1), clip(1), tapervoledge(1)
