.na
.nh
.TH mrctaper 1 2.42 BL3DEMC
.SH NAME
mrctaper \- Tapers edges of images between actual and filled-in values
.SH SYNOPSIS
mrctaper [-i] [-t #] [-z min,max] input_file [output_file]
.SH DESCRIPTION
mrctaper will taper the edges between actual image data and areas that have
been filled in with a constant value, thus eliminating the sharp transitions
produced when images are transformed
by programs such as newstack(1) or blendmont(1).  By default, the program
will taper outside the actual image data by replicating the pixels along the 
edge and attenuating their intensity toward the filled-in value for pixels 
farther from the edge.  This makes the features
on the edge of the area appear smeared out into the filled-in area.  This
tapering will preserve all of the actual data but may produce undesirable 
artifacts in some cases.  Optionally, the program can taper inside, by 
attenuating the intensity of actual pixels toward the filled-in value and 
doing so progressively less for pixels farther from the edge.  This method
will throw away some information but will be most successful at preventing 
artifacts in Fourier transforms.

.SS Options
.TP
.B -i
Taper inside rather than outside.
.TP
.B -t #
Taper over the given number of pixels.  The default value is 1% of the mean
of the X and Y sizes of the image, but at least 16 pixels and no more than 127.
.TP
.B -z <min,max>
Operate only on sections from
.B min
to
.B max.
Sections are numbered from 0.  If a new output file is being
created, it will contain only the sections from min to max in the input file.
.SH FILES
If no output file name is given, the data are written back into the input file.
.SH AUTHOR
David Mastronarde  <mast@colorado.edu>
.SH SEE ALSO
newstack(1), blendmont(1)
